<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\LocaisAtendimentoService;
use FM\Traits\TResponse;

class LocaisAtendimentoController extends FMCrud {

    use TResponse;

    protected $LocaisAtendimentoService;

    public function __construct($crudService, $environment, LocaisAtendimentoService $LocaisAtendimentoService) {
            parent::__construct($crudService, $environment);
            $this->LocaisAtendimentoService = $LocaisAtendimentoService;
    }
    // INTEGRAÇÃO SM
    public function getContratosConfigurarLocais(Request $request, Response $response) {
        try {
                $data = $this->LocaisAtendimentoService->getContratosConfigurarLocais();
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function getLocaisSM(Request $request, Response $response) {
        try {
                $data = $this->LocaisAtendimentoService->getLocaisSM($request->getParameters());
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function salvarLocalSm(Request $request, Response $response) {
        try {
                $data = $this->LocaisAtendimentoService->salvarLocalSm($request->getParameters());
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }
    // -----------
    public function getClientes(Request $request, Response $response) {
        try {
                $data = $this->LocaisAtendimentoService->getClientes();
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function getLocais(Request $request, Response $response) {
        try {
                $data = $this->LocaisAtendimentoService->getLocais();
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function getTiposDeLocais(Request $request, Response $response) {
        try {
                $data = $this->LocaisAtendimentoService->getTiposDeLocais($request->getParameters());
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function getChecklistPadrao(Request $request, Response $response) {
        try {
                $data = $this->LocaisAtendimentoService->getChecklistPadrao();
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function getSetorLocalAtendimento(Request $request, Response $response) {
        try {
                $data = $this->LocaisAtendimentoService->getSetorLocalAtendimento();
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function inserirNovoLocal(Request $request, Response $response) {
        try {
                $data = $this->LocaisAtendimentoService->inserirNovoLocal($request->getParameters());
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function getClientesQueAgrupamLocais(Request $request, Response $response) {
        try {
                $data = $this->LocaisAtendimentoService->getClientesQueAgrupamLocais();
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function getLocaisAgrupados(Request $request, Response $response) {
        try {
                $data = $this->LocaisAtendimentoService->getLocaisAgrupados($request->getParameters());
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function alterarCorCliente(Request $request, Response $response) {
        try {
                $data = $this->LocaisAtendimentoService->alterarCorCliente($request->getParameters());
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function atualizarLocal(Request $request, Response $response) {
        try {
                $data = $this->LocaisAtendimentoService->atualizarLocal($request->getParameters());
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function inativarLocais(Request $request, Response $response) {
        try {
                $data = $this->LocaisAtendimentoService->inativarLocais($request->getParameters());
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }
    

  // --- Funções da TAB NOVO TIPO DE LOCAL
    public function getTipoDeLocal(Request $request, Response $response) {
        try {
                $data = $this->LocaisAtendimentoService->getTipoDeLocal();
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function atualizarTipoLocal(Request $request, Response $response) {
        try {
                $data = $this->LocaisAtendimentoService->atualizarTipoLocal($request->getParameters());
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function excluirTipoLocal(Request $request, Response $response) {
        try {

                $data = $this->LocaisAtendimentoService->excluirTipoLocal($request->getParameters());
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }
}

?>
