<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use FM\Traits\TQuery;

class GerenciamentoChkFactory {
    use TQuery;

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->alias = "gerenciamento";
    }

    public function listInspectionTask($param,$params) {
        
        $sql = "SELECT FCM_GERENCIAMENTOCHK.DTHORAAGEND, FCM_GERENCIAMENTOCHK.NMGERENCIAMENTOCHK, FCM_GERENCIAMENTOCHK.DTHRFINALAGEND, 
                   FCM_LOCALCLI.DSCORIDLOCAL, MAX(FCM_ATIVIDADE.DSCORIDATIVIDADE) AS CORATIVIDADE, FCM_GERENCIAMENTOCHK.NRGERENCIAMENTOCHK
                        FROM FCM_GERENCIAMENTOCHK
                        JOIN FCM_LOCALCLI
                          ON FCM_LOCALCLI.NRLOCALCLIENTE = FCM_GERENCIAMENTOCHK.NRLOCALCLIENTE
                        JOIN FCM_ATIVIDADECHK
                          ON FCM_ATIVIDADECHK.NRCHECKLIST = FCM_GERENCIAMENTOCHK.NRCHECKLIST
                        JOIN FCM_ATIVIDADE
                          ON FCM_ATIVIDADE.NRATIVIDADE = FCM_ATIVIDADECHK.NRATIVIDADE
                 WHERE TRUNC(FCM_GERENCIAMENTOCHK.DTHORAAGEND) BETWEEN TO_DATE( :startPeriod, 'YYYY-MM-DD') AND TO_DATE( :finishPeriod, 'YYYY-MM-DD')
                         AND FCM_GERENCIAMENTOCHK.CDOPERADOR = :CDOPERADOR ".$params."
                    GROUP BY FCM_GERENCIAMENTOCHK.DTHORAAGEND, FCM_GERENCIAMENTOCHK.NMGERENCIAMENTOCHK, FCM_GERENCIAMENTOCHK.DTHRFINALAGEND, FCM_LOCALCLI.DSCORIDLOCAL, FCM_GERENCIAMENTOCHK.NRGERENCIAMENTOCHK
                   ORDER BY DTHORAAGEND";
        
        $std = $this->connection->prepare($sql);
        $std->execute($param);
        return $std->fetchAll();
    } 

    public function transferVistoria($param, $nrgerenciamentochk) {

        $sql = "UPDATE FCM_GERENCIAMENTOCHK
                   SET CDOPERADOR = :CDOPERADOR,
                        DTULTATU = SYSDATE,
                        CDOPERULTATU = :CDOPERULTATU,
                        NRORGULTATU = :NRORGULTATU
                 WHERE NRGERENCIAMENTOCHK IN (".$nrgerenciamentochk.")";
        
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }

    public function dadosTransfer($param) {
        $sql = "UPDATE FCM_GERENCIAMENTOCHK
                   SET NRFUNCIONARIO = ".$param['nr']."
                 WHERE NRGERENCIAMENTOCHK IN (".$param['list'].")";
        
        $std = $this->connection->prepare($sql);
        $std->execute();
    }

    public function dadosVistoria($param) {
        $sql = "SELECT NRGERENCIAMENTOCHK, CDOPERADOR, DTHORAAGEND
                  FROM FCM_GERENCIAMENTOCHK
                 WHERE NRGERENCIAMENTOCHK = ".$param;
        
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function gerenciamentoChkInnerJoinChecklist($params) {
        $useParams = false;
        $sqlCode = "SELECT gerenciamento.NRGERENCIAMENTOCHK,
            gerenciamento.NRLOCALCLIENTE, gerenciamento.NRFUNCIONARIO,
            gerenciamento.IDSITUACAOGERCHK, gerenciamento.DTHORAAGEND,
            gerenciamento.IDATIVO, gerenciamento.NRORG,
            gerenciamento.DTINCLUSAO, gerenciamento.CDOPERINCLUSAO,
            gerenciamento.NRORGINCLUSAO, gerenciamento.DTULTATU,
            gerenciamento.CDOPERULTATU, gerenciamento.NRORGULTATU,
            gerenciamento.NMGERENCIAMENTOCHK, chklist.NRSETOR,
            local.DSCORIDLOCAL, gerenciamento.DTHRFINALAGEND,
            atv.DSCORIDATIVIDADE
            FROM FCM_GERENCIAMENTOCHK gerenciamento
            INNER JOIN FCM_CHECKLIST chklist
            ON chklist.NRCHECKLIST = gerenciamento.NRCHECKLIST
            INNER JOIN FCM_LOCALCLI local
            ON local.NRLOCALCLIENTE = gerenciamento.NRLOCALCLIENTE
            INNER JOIN FCM_ATIVIDADECHK atvchk
            ON atvchk.NRCHECKLIST = gerenciamento.NRCHECKLIST
            INNER JOIN FCM_ATIVIDADE atv
            ON atv.NRATIVIDADE = atvchk.NRATIVIDADE";
            
        $paramKeys = array_keys($params);
        $query = "";
        $paramCount = 0;
        $useAnd = false;
        foreach($paramKeys as $key) {
            if ($useAnd) {
                $query .= " AND ";
            } else {
                $query .= " WHERE ";
                $useAnd = true;
            }
            
            if ($key == "NRCHECKLIST") {
                $alias = "chklist";
            } else if($key == "NRTIPOLOCALCLI" || $key == "NRSETOR") {
                $alias = "local";
            } else {
                $alias = "gerenciamento";
            }
            
            if (is_array($params[$key])) {
                $query .= $alias . "." . $key . " IN (";
                $lenParams = count($params[$key]);
                for ($i = 0; $i < $lenParams; $i++) {
                    $query .= $params[$key][$i];
                    if ($i !== $lenParams - 1) {
                        $query .= ", ";
                    }
                }
                $query .= ") ";
                unset($params[$key]);
            } else {
                $query .= $alias . "." . $key . " = :" . $key;
                $paramCount++;
            }
        }
        $sqlCode .= $query;
        $std = $this->connection->prepare($sqlCode);
        if ($paramCount > 0) {
            $std->execute($params);   
        } else {
            $std->execute();
        }
        return $std->fetchAll();
    }
    
    public function updateVistoria($params) {
        debugApi([$params]);

        /* $sql "UPDATE FCM_GERENCIAMENTOCHK
                SET CDOPERADOR = :CDOPERADOR
                WHERE NRGERENCIAMENTOCHK IN (:NRGERENCIAMENTOCHK)";

        $std = $this->connection->prepare($sql);
        $std->execute(); */
    }
}

?>