/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_REFEBIBL                                                                                               */
/* Tabela : REFEBIBL                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 09/11/2004 - Rafael dos Santos Lopes                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_REFEBIBL
BEFORE INSERT OR UPDATE OR DELETE
ON REFEBIBL FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUREBI := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.NMREFEBIBL,0) <> NVL(:NEW.NMREFEBIBL,0)) OR
           (NVL(:OLD.DSREFEBIBL,0) <> NVL(:NEW.DSREFEBIBL,0)) THEN
         :NEW.DTULTATUREBI := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('REFEBIBL', '', 'CDREFEBIBL='||:OLD.CDREFEBIBL||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE REFEBIBL MODIFY DTULTATUREBI DEFAULT SYSDATE
/

